-- MySQL dump 10.10
--
-- Host: localhost    Database: nconf
-- ------------------------------------------------------
-- Server version	5.0.22

/*!40101 SET @OLD_CHARACTER_SET_CLIENT=@@CHARACTER_SET_CLIENT */;
/*!40101 SET @OLD_CHARACTER_SET_RESULTS=@@CHARACTER_SET_RESULTS */;
/*!40101 SET @OLD_COLLATION_CONNECTION=@@COLLATION_CONNECTION */;
/*!40101 SET NAMES utf8 */;
/*!40103 SET @OLD_TIME_ZONE=@@TIME_ZONE */;
/*!40103 SET TIME_ZONE='+00:00' */;
/*!40014 SET @OLD_UNIQUE_CHECKS=@@UNIQUE_CHECKS, UNIQUE_CHECKS=0 */;
/*!40014 SET @OLD_FOREIGN_KEY_CHECKS=@@FOREIGN_KEY_CHECKS, FOREIGN_KEY_CHECKS=0 */;
/*!40101 SET @OLD_SQL_MODE=@@SQL_MODE, SQL_MODE='NO_AUTO_VALUE_ON_ZERO' */;
/*!40111 SET @OLD_SQL_NOTES=@@SQL_NOTES, SQL_NOTES=0 */;

--
-- Table structure for table `ConfigAttrs`
--

DROP TABLE IF EXISTS `ConfigAttrs`;
CREATE TABLE `ConfigAttrs` (
  `id_attr` int(10) unsigned NOT NULL auto_increment,
  `attr_name` varchar(60) NOT NULL default '',
  `friendly_name` varchar(80) NOT NULL default '',
  `description` varchar(250) default NULL,
  `datatype` enum('text','password','select','assign_one','assign_many','assign_cust_order') NOT NULL default 'text',
  `max_length` int(11) default NULL,
  `poss_values` text,
  `predef_value` varchar(1024) default NULL,
  `mandatory` enum('yes','no') NOT NULL default 'no',
  `ordering` int(11) NOT NULL default '0',
  `visible` enum('yes','no') NOT NULL default 'yes',
  `write_to_conf` enum('yes','no') NOT NULL default 'yes',
  `naming_attr` enum('yes','no') NOT NULL default 'no',
  `link_as_child` enum('yes','no') NOT NULL default 'no',
  `link_bidirectional` enum('yes','no') NOT NULL default 'no',
  `fk_show_class_items` int(10) unsigned default NULL,
  `fk_id_class` int(10) unsigned NOT NULL default '0',
  PRIMARY KEY  (`id_attr`),
  KEY `fk_show_class_items` (`fk_show_class_items`),
  KEY `fk_id_class` (`fk_id_class`),
  CONSTRAINT `ConfigAttrs_ibfk_1` FOREIGN KEY (`fk_show_class_items`) REFERENCES `ConfigClasses` (`id_class`) ON DELETE CASCADE ON UPDATE CASCADE,
  CONSTRAINT `ConfigAttrs_ibfk_2` FOREIGN KEY (`fk_id_class`) REFERENCES `ConfigClasses` (`id_class`) ON DELETE CASCADE ON UPDATE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

--
-- Dumping data for table `ConfigAttrs`
--


/*!40000 ALTER TABLE `ConfigAttrs` DISABLE KEYS */;
LOCK TABLES `ConfigAttrs` WRITE;
INSERT INTO `ConfigAttrs` VALUES (1,'server_name','server name',NULL,'text',255,'','','yes',1,'yes','no','yes','no','no',NULL,10),(6,'server_name','server name',NULL,'text',255,'','','yes',1,'yes','no','yes','no','no',NULL,11),(12,'icon_image_alt','OS description',NULL,'text',255,'','','yes',1,'yes','yes','yes','no','no',NULL,9),(13,'icon_image','icon image','img/logos/...','text',255,'','base/linux40.gif','no',2,'yes','yes','no','no','no',NULL,9),(14,'statusmap_image','statusmap image','img/logos/...','text',255,'','base/linux40.gd2','no',3,'yes','yes','no','no','no',NULL,9),(15,'host_name','hostname',NULL,'text',255,'','','yes',1,'yes','yes','yes','no','no',NULL,1),(16,'alias','alias','alias or FQDN','text',255,'','','no',2,'yes','yes','no','no','no',NULL,1),(17,'address','address','IP-address / DNS name','text',255,'','','yes',3,'yes','yes','no','no','no',NULL,1),(18,'os','OS','','assign_one',0,'','Linux','yes',4,'yes','no','no','no','no',9,1),(19,'check_period','check period','time period to run checks','assign_one',0,'','24x7','no',8,'yes','yes','no','no','no',7,1),(20,'notification_period','notification period','time period to alarm','assign_one',0,'','24x7','no',9,'yes','yes','no','no','no',7,1),(22,'contact_groups','contact groups','responsible group','assign_many',0,'','','no',12,'yes','yes','no','no','no',6,1),(23,'parents','parent hosts','','assign_many',0,'','','no',14,'yes','yes','no','no','no',1,1),(24,'notes','notes',NULL,'text',1024,'','','no',15,'yes','yes','no','no','no',NULL,1),(25,'notes_url','notes URL',NULL,'text',1024,'','','no',16,'yes','yes','no','no','no',NULL,1),(26,'monitored_by','monitored by','monitoring server (empty = not monitored)','assign_one',0,'','','no',6,'yes','no','no','no','no',10,1),(27,'hostgroup_name','hostgroup name',NULL,'text',255,'','','yes',1,'yes','yes','yes','no','no',NULL,2),(28,'alias','alias',NULL,'text',255,'','','yes',2,'yes','yes','no','no','no',NULL,2),(29,'members','assign host to hostgroup',NULL,'assign_many',0,'','','no',3,'yes','yes','no','yes','yes',1,2),(30,'command_name','check command name',NULL,'text',255,'','','yes',1,'yes','yes','yes','no','no',NULL,8),(31,'command_line','check command line',NULL,'text',1024,'','','yes',3,'yes','yes','no','no','no',NULL,8),(32,'timeperiod_name','timeperiod name',NULL,'text',255,'','','yes',1,'yes','yes','yes','no','no',NULL,7),(33,'alias','alias',NULL,'text',255,'','','yes',2,'yes','yes','no','no','no',NULL,7),(34,'sunday','sunday timeperiod','00:00-24:00','text',255,'','','no',3,'yes','yes','no','no','no',NULL,7),(35,'monday','monday timeperiod','00:00-24:00','text',255,'','','no',4,'yes','yes','no','no','no',NULL,7),(36,'tuesday','tuesday timeperiod','00:00-24:00','text',255,'','','no',5,'yes','yes','no','no','no',NULL,7),(37,'wednesday','wednesday timeperiod','00:00-24:00','text',255,'','','no',6,'yes','yes','no','no','no',NULL,7),(38,'thursday','thursday timeperiod','00:00-24:00','text',255,'','','no',7,'yes','yes','no','no','no',NULL,7),(39,'friday','friday timeperiod','00:00-24:00','text',255,'','','no',8,'yes','yes','no','no','no',NULL,7),(40,'saturday','saturday timeperiod','00:00-24:00','text',255,'','','no',9,'yes','yes','no','no','no',NULL,7),(47,'contact_name','contact name','username','text',255,'','','yes',1,'yes','yes','yes','no','no',NULL,5),(48,'alias','alias','firstname lastname','text',255,'','','yes',2,'yes','yes','no','no','no',NULL,5),(49,'host_notification_period','host notification period','host alarming timeperiod','assign_one',0,'','','no',3,'yes','yes','no','no','no',7,5),(50,'service_notification_period','service notification period','service alarming timeperiod','assign_one',0,'','','no',4,'yes','yes','no','no','no',7,5),(51,'host_notification_options','host notification options','possible values: d,u,r,f,[n]','text',20,'','d','no',5,'yes','yes','no','no','no',NULL,5),(52,'service_notification_options','service notification options','possible values: w,u,c,r,f,[n]','text',20,'','c','no',6,'yes','yes','no','no','no',NULL,5),(53,'host_notification_commands','host notification commands','default: notify-host-by-email','assign_many',0,'','notify-host-by-email','no',9,'yes','yes','no','no','no',13,5),(54,'service_notification_commands','service notification commands','default: notify-service-by-email','assign_many',0,'','notify-service-by-email','no',10,'yes','yes','no','no','no',13,5),(55,'email','e-mail address',NULL,'text',255,'','','yes',7,'yes','yes','no','no','no',NULL,5),(56,'pager','pager / phone nr.','(country code) + (prefix) + (number)','text',255,'','','no',8,'yes','yes','no','no','no',NULL,5),(57,'contactgroup_name','contactgroup name',NULL,'text',255,'','','yes',1,'yes','yes','yes','no','no',NULL,6),(58,'alias','alias',NULL,'text',255,'','','yes',2,'yes','yes','no','no','no',NULL,6),(59,'members','assign contact to contactgroup',NULL,'assign_many',0,'','','no',3,'yes','yes','no','yes','yes',5,6),(60,'service_description','service name',NULL,'text',255,'','','yes',1,'yes','yes','yes','no','no',NULL,3),(61,'check_command','check command',NULL,'assign_one',0,'','','yes',3,'yes','yes','no','no','no',8,3),(62,'host_name','assigned to host',NULL,'assign_one',0,'','','yes',4,'yes','yes','no','no','no',1,3),(63,'check_period','check period','time period to run checks','assign_one',0,'','24x7','no',5,'yes','yes','no','no','no',7,3),(64,'notification_period','notification period','time period to alarm','assign_one',0,'','','no',6,'yes','yes','no','no','no',7,3),(65,'contact_groups','contact groups','responsible group','assign_many',0,'','','no',8,'yes','yes','no','no','no',6,3),(67,'notes','notes',NULL,'text',1024,'','','no',9,'yes','yes','no','no','no',NULL,3),(68,'notes_url','notes URL',NULL,'text',1024,'','','no',10,'yes','yes','no','no','no',NULL,3),(69,'event_handler_enabled','event-handler enabled',NULL,'select',0,'0::1','0','no',23,'no','yes','no','no','no',NULL,3),(70,'servicegroup_name','servicegroup name',NULL,'text',255,'','','yes',1,'yes','yes','yes','no','no',NULL,4),(71,'alias','alias',NULL,'text',255,'','','yes',2,'yes','yes','no','no','no',NULL,4),(72,'members','assign service to servicegroup',NULL,'assign_many',0,'','','no',3,'yes','yes','no','yes','yes',3,4),(73,'template_name','host preset name',NULL,'text',255,'','','yes',1,'yes','no','yes','no','no',NULL,12),(74,'command_name','host preset commands','auto-create services for a new host based on these checkcommands','assign_many',0,'','','no',3,'yes','no','no','yes','no',8,12),(75,'host-preset','host preset','predefined services / host-alive check','assign_one',0,'','linux-server','yes',5,'yes','no','no','no','no',12,1),(79,'check_params','params for check command',NULL,'text',1024,'','!','no',24,'yes','no','no','no','no',NULL,3),(81,'hostalive_check','host-alive check','','assign_one',0,'','check-host-alive','yes',2,'yes','yes','no','no','no',13,12),(86,'command_syntax','params description','short description of each parameter (comma separated, same order)','text',1024,'','','no',5,'yes','no','no','no','no',NULL,8),(87,'default_params','default command params','separated by \"!\"','text',1024,'','!','no',4,'yes','no','no','no','no',NULL,8),(91,'collector_check_freshness','check freshness (of collectors)','value is applied to \"check_ssh\" service on \"host is collector\" flagged hosts','select',0,'0::1','1','yes',2,'yes','no','no','no','no',NULL,11),(92,'collector_freshness_threshold','freshness threshold (of collectors)','value is applied to \"check_ssh\" service on \"host is collector\" flagged hosts; sets the time until service becomes \"stale\" (useful to verify connection between collectors and monitors)','text',5,'','900','yes',3,'yes','no','no','no','no',NULL,11),(93,'host_is_collector','host is collector','is this host a collector itself?','select',0,'no::yes','no','yes',7,'yes','no','no','no','no',NULL,1),(94,'command_param_count','amount of params','','select',0,'0::1::2::3::4::5::6::7::8::9::10','1','yes',6,'yes','no','no','no','no',NULL,8),(95,'user_password','user password','password for NConf & Nagios GUI','password',255,'','','no',11,'no','no','no','no','no',NULL,5),(96,'nc_permission','nconf permissions','defines the permissions in NConf','select',0,'no access::user::admin','user','no',12,'no','no','no','no','no',NULL,5),(97,'nagios_access','nagios access','defines access to the Nagios GUI','select',0,'enabled::disabled','enabled','no',13,'no','no','no','no','no',NULL,5),(98,'command_name','misc command name','','text',255,'','','yes',1,'yes','yes','yes','no','no',NULL,13),(99,'command_line','misc command line','','text',1024,'','','yes',2,'yes','yes','no','no','no',NULL,13),(101,'action_url','action URL','PNP URL (if installed)','select',0,'/nagios/html/pnp4nagios/index.php?host=$HOSTNAME$::https://URL_TO_NCONF/dependency.php?xmode=nagiosview&hostname=$HOSTNAME$&service_link=https://URL_TO_NAGIOS/nagios/cgi-bin/extinfo.cgi::https://URL_TO_NCONF/dependency.php?xmode=nagiosview&hostname=$HOSTNAME$&service_link=https://URL_TO_NAGIOS/nagios/cgi-bin/extinfo.cgi&pnp_link=https://URL_TO_NAGIOS/nagios/html/pnp4nagios/index.php','','no',17,'yes','yes','no','no','no',NULL,1),(102,'action_url','action URL','PNP URL (if installed)','select',0,'/nagios/html/pnp4nagios/index.php?host=$HOSTNAME$&srv=$SERVICEDESC$','','no',11,'yes','yes','no','no','no',NULL,3),(103,'default_service_name','default service name','default name to use for new services','text',255,NULL,NULL,'no',2,'yes','no','no','no','no',NULL,8),(104,'notes','notes',NULL,'text',1024,NULL,NULL,'no',5,'yes','yes','no','no','no',NULL,2),(105,'notes_url','notes URL',NULL,'text',1024,NULL,NULL,'no',6,'yes','yes','no','no','no',NULL,2),(106,'notes','notes',NULL,'text',1024,NULL,NULL,'no',5,'yes','yes','no','no','no',NULL,4),(107,'notes_url','notes URL',NULL,'text',1024,NULL,NULL,'no',6,'yes','yes','no','no','no',NULL,4),(108,'name','template name','','text',255,'','','yes',1,'yes','yes','yes','no','no',NULL,14),(109,'host_name','host name','mandatory if \"register\" = 1','text',255,'','','no',2,'no','no','no','no','no',NULL,14),(110,'register','register','display this template as a host in Nagios','select',0,'0::1','0','yes',3,'no','yes','no','no','no',NULL,14),(111,'check_period','check period','time period to run checks','assign_one',0,'','','no',4,'yes','yes','no','no','no',7,14),(112,'notification_period','notification period','time period to alarm','assign_one',0,'','','no',5,'yes','yes','no','no','no',7,14),(113,'check_command','check command','host-alive check','assign_one',0,'','','no',6,'yes','yes','no','no','no',13,14),(114,'use','parent template(s)','parent template(s) to inherit from','assign_cust_order',0,'','','no',7,'yes','yes','no','no','no',14,14),(115,'contact_groups','contact groups','responsible group','assign_many',0,'','','no',8,'yes','yes','no','no','no',6,14),(116,'notes','notes',NULL,'text',1024,'','','no',9,'yes','yes','no','no','no',NULL,14),(117,'notes_url','notes URL',NULL,'text',1024,'','','no',10,'yes','yes','no','no','no',NULL,14),(118,'action_url','action URL','PNP URL (if installed)','select',0,'/nagios/html/pnp4nagios/index.php?host=$HOSTNAME$::https://URL_TO_NCONF/dependency.php?xmode=nagiosview&hostname=$HOSTNAME$&service_link=https://URL_TO_NAGIOS/nagios/cgi-bin/extinfo.cgi::https://URL_TO_NCONF/dependency.php?xmode=nagiosview&hostname=$HOSTNAME$&service_link=https://URL_TO_NAGIOS/nagios/cgi-bin/extinfo.cgi&pnp_link=https://URL_TO_NAGIOS/nagios/html/pnp4nagios/index.php','','no',11,'yes','yes','no','no','no',NULL,14),(119,'max_check_attempts','max check attempts','number of times to retry checking','text',4,'','','no',12,'yes','yes','no','no','no',NULL,14),(120,'check_interval','check interval','number of [min.] between regularly scheduled checks','text',4,'','','no',13,'yes','yes','no','no','no',NULL,14),(121,'retry_interval','retry interval','number of [min.] to wait before scheduling a re-check','text',4,'','','no',14,'yes','yes','no','no','no',NULL,14),(122,'notification_interval','notification interval','number of [min.] to wait before re-notifying a contact','text',4,'','','no',16,'yes','yes','no','no','no',NULL,14),(123,'notification_options','notification options','possible values: d,u,r,f,s,[n]','text',20,'','','no',17,'yes','yes','no','no','no',NULL,14),(124,'active_checks_enabled','active checking','do active checking of hosts','select',0,'0::1','','no',18,'yes','yes','no','no','no',NULL,14),(125,'passive_checks_enabled','passive checking','do passive checking of hosts','select',0,'0::1','','no',19,'yes','yes','no','no','no',NULL,14),(126,'notifications_enabled','notification enabled','send notifications for hosts','select',0,'0::1','','no',20,'yes','yes','no','no','no',NULL,14),(127,'check_freshness','check freshness','check age of last check results','select',0,'0::1','','no',21,'yes','yes','no','no','no',NULL,14),(128,'freshness_threshold','freshness threshold','age threshold in [sec.]','text',5,'','','no',22,'yes','yes','no','no','no',NULL,14),(129,'name','template name','','text',255,'','','yes',1,'yes','yes','yes','no','no',NULL,15),(130,'service_description','service name','mandatory if \"register\" = 1','text',255,'','','no',2,'no','no','no','no','no',NULL,15),(131,'register','register','display this template as a service in Nagios','select',0,'0::1','0','yes',3,'no','yes','no','no','no',NULL,15),(132,'check_period','check period','time period to run checks','assign_one',0,'','','no',4,'yes','yes','no','no','no',7,15),(133,'notification_period','notification period','time period to alarm','assign_one',0,'','','no',5,'yes','yes','no','no','no',7,15),(134,'use','parent template(s)','parent template(s) to inherit from','assign_cust_order',0,'','','no',6,'yes','yes','no','no','no',15,15),(135,'contact_groups','contact groups','responsible group','assign_many',0,'','','no',7,'yes','yes','no','no','no',6,15),(136,'notes','notes',NULL,'text',1024,'','','no',8,'yes','yes','no','no','no',NULL,15),(137,'notes_url','notes URL',NULL,'text',1024,'','','no',9,'yes','yes','no','no','no',NULL,15),(138,'action_url','action URL','PNP URL (if installed)','select',0,'/nagios/html/pnp4nagios/index.php?host=$HOSTNAME$&srv=$SERVICEDESC$','','no',10,'yes','yes','no','no','no',NULL,15),(139,'max_check_attempts','max check attempts','number of times to retry checking','text',4,'','','no',11,'yes','yes','no','no','no',NULL,15),(140,'check_interval','check interval','number of [min.] between regularly scheduled checks','text',4,'','','no',12,'yes','yes','no','no','no',NULL,15),(141,'retry_interval','retry interval','number of [min.] to wait before scheduling a re-check','text',4,'','','no',13,'yes','yes','no','no','no',NULL,15),(142,'notification_interval','notification interval','number of [min.] to wait before re-notifying a contact','text',4,'','','no',15,'yes','yes','no','no','no',NULL,15),(143,'notification_options','notification options','possible values: w,u,c,r,f,s,[n]','text',20,'','','no',16,'yes','yes','no','no','no',NULL,15),(144,'active_checks_enabled','active checking','do active checking of services','select',0,'0::1','','no',17,'yes','yes','no','no','no',NULL,15),(145,'passive_checks_enabled','passive checking','do passive checking of services','select',0,'0::1','','no',18,'yes','yes','no','no','no',NULL,15),(146,'notifications_enabled','notification enabled','send notifications for services','select',0,'0::1','','no',19,'yes','yes','no','no','no',NULL,15),(147,'check_freshness','check freshness','check age of last check results','select',0,'0::1','','no',20,'yes','yes','no','no','no',NULL,15),(148,'freshness_threshold','freshness threshold','age threshold in [sec.]','text',5,'','','no',21,'yes','yes','no','no','no',NULL,15),(149,'use','host template(s)','host template(s) to inherit properties from','assign_cust_order',NULL,NULL,NULL,'no',10,'yes','yes','no','no','no',14,1),(150,'use','service template(s)','service template(s) to inherit properties from','assign_cust_order',NULL,NULL,NULL,'no',7,'yes','yes','no','no','no',15,3),(151,'host_template','host template(s)','add the following template(s) to all hosts monitored by this server','assign_cust_order',NULL,NULL,'Default_collector_server','no',2,'yes','no','no','no','no',14,10),(152,'service_template','service template(s)','add the following template(s) to all services monitored by this server','assign_cust_order',NULL,NULL,'Default_collector_server','no',3,'yes','no','no','no','no',15,10),(153,'stale_service_command','stale service command','\"dummy\" command to run for stale services','assign_one',NULL,NULL,'service_is_stale','no',4,'yes','no','no','no','no',13,11),(154,'host_template','host template(s)','add the following template(s) to all hosts monitored by this server','assign_cust_order',NULL,NULL,'Default_monitor_server','no',5,'yes','no','no','no','no',14,11),(155,'service_template','service template(s)','add the following template(s) to all services monitored by this server','assign_cust_order',NULL,NULL,'Default_monitor_server','no',6,'yes','no','no','no','no',15,11),(156,'host_template','host template(s)','add the following template(s) to all hosts linked with this timeperiod','assign_cust_order',NULL,NULL,'','no',10,'yes','no','no','no','no',14,7),(157,'service_template','service template(s)','add the following template(s) to all services linked with this timeperiod','assign_cust_order',NULL,NULL,'','no',11,'yes','no','no','no','no',15,7),(158,'dependency_name','dependency name','description for the dependency definition','text',1024,'','','yes',1,'yes','no','yes','no','no',NULL,16),(159,'execution_failure_criteria','execution failure criteria','possible values: o,d,u,p,n','text',20,'','','no',2,'yes','yes','no','no','no',NULL,16),(160,'notification_failure_criteria','notification failure criteria','possible values: o,d,u,p,n','text',20,'','','no',3,'yes','yes','no','no','no',NULL,16),(161,'dependency_period','dependency time period','restrict dependency to this time period','assign_one',0,'','','no',4,'yes','yes','no','no','no',7,16),(162,'inherits_parent','inherit dependencies','inherit dependencies from host(s) depended on','select',0,'0::1','0','no',5,'yes','yes','no','no','no',NULL,16),(163,'host_name','master host(s)','host(s) being depended upon','assign_many',0,'','','no',6,'yes','yes','no','no','no',1,16),(164,'hostgroup_name','master hostgroup(s)','hostgroup(s) being depended upon','assign_many',0,'','','no',7,'yes','yes','no','no','no',2,16),(165,'dependent_host_name','dependent host(s)','the dependent host(s)','assign_many',0,'','','no',8,'yes','yes','no','no','no',1,16),(166,'dependent_hostgroup_name','dependent hostgroup(s)','the dependent hostgroup(s)','assign_many',0,'','','no',9,'yes','yes','no','no','no',2,16),(167,'dependency_name','dependency name','description for the dependency definition','text',1024,'','','yes',1,'yes','no','yes','no','no',NULL,17),(168,'execution_failure_criteria','execution failure criteria','possible values: o,w,u,c,p,n','text',20,'','','no',2,'yes','yes','no','no','no',NULL,17),(169,'notification_failure_criteria','notification failure criteria','possible values: o,w,u,c,p,n','text',20,'','','no',3,'yes','yes','no','no','no',NULL,17),(170,'dependency_period','dependency time period','restrict dependency to this time period','assign_one',0,'','','no',4,'yes','yes','no','no','no',7,17),(171,'inherits_parent','inherit dependencies','inherit dependencies from service(s) depended on','select',0,'0::1','0','no',5,'yes','yes','no','no','no',NULL,17),(172,'service_description','master service(s)','service(s) being depended upon','assign_many',0,'','','yes',6,'yes','yes','no','no','no',3,17),(173,'dependent_service_description','dependent service(s)','the dependent service(s)','assign_many',0,'','','yes',7,'yes','yes','no','no','no',3,17),(174,'service_enabled','service enabled','enable / disable this service','select',NULL,'yes::no','yes','yes',2,'yes','no','no','no','no',NULL,3),(175,'hostgroup_members','assign hostgroup to hostgroup','','assign_many',0,'','','no',4,'yes','yes','no','yes','no',2,2),(176,'servicegroup_members','assign servicegroup to servicegroup','','assign_many',0,'','','no',4,'yes','yes','no','yes','no',4,4),(177,'contactgroup_members','assign contactgroup to contactgroup','','assign_many',0,'','','no',4,'yes','yes','no','yes','no',6,6),(178,'service_template','default service template(s)','add the following template(s) to all advanced-/services linked with this checkcommand (linked templates are not visible in the GUI because they are linked when the config is generated)','assign_cust_order',NULL,NULL,'','no',7,'yes','no','no','no','no',15,8),(179,'default_service_dependency','default command to depend upon','make all services using the current command dependent on services on the same host using this command selected here','assign_one',NULL,NULL,'','no',8,'yes','no','no','no','no',8,8),(180,'dependency_execution_failure_criteria','execution_failure_criteria for dependency','the \'execution_failure_criteria\' value to use for the dependency; possible values: o,w,u,c,p,[n]','text',20,'','','no',9,'yes','no','no','no','no',NULL,8),(181,'dependency_notification_failure_criteria','notification_failure_criteria for dependency','the \'notification_failure_criteria\' value to use for the dependency; possible values: o,w,u,c,p,[n]','text',20,'','','no',10,'yes','no','no','no','no',NULL,8),(182,'advanced_service_name','advanced service name','NConf internal service name','text',255,'','','yes',1,'yes','no','yes','no','no',NULL,18),(183,'service_description','service description','Nagios specific service description','text',255,'','','yes',2,'yes','yes','no','no','no',NULL,18),(184,'check_command','check command','','assign_one',0,'','','yes',3,'yes','yes','no','no','no',8,18),(185,'check_period','check period','time period to run checks','assign_one',0,'','','no',4,'yes','yes','no','no','no',7,18),(186,'notification_period','notification period','time period to alarm','assign_one',0,'','','no',5,'yes','yes','no','no','no',7,18),(187,'host_name','assign advanced-service to host','','assign_many',0,'','','no',6,'yes','yes','no','no','no',1,18),(188,'hostgroup_name','assign advanced-service to hostgroup','','assign_many',0,'','','no',7,'yes','yes','no','no','yes',2,18),(189,'servicegroups','assign advanced-service to servicegroup','','assign_many',0,'','','no',8,'yes','yes','no','no','yes',4,18),(190,'use','service template(s)','parent template(s) to inherit from','assign_cust_order',0,'','','no',9,'yes','yes','no','no','no',15,18),(191,'contact_groups','contact groups','responsible group','assign_many',0,'','','no',10,'yes','yes','no','no','no',6,18),(192,'notes','notes','','text',1024,'','','no',11,'yes','yes','no','no','no',NULL,18),(193,'notes_url','notes URL','','text',1024,'','','no',12,'yes','yes','no','no','no',NULL,18),(194,'action_url','action URL','PNP URL (if installed)','select',0,'/nagios/html/pnp4nagios/index.php?host=$HOSTNAME$&srv=$SERVICEDESC$','','no',13,'yes','yes','no','no','no',NULL,18),(195,'max_check_attempts','max check attempts','number of times to retry checking','text',4,'','','no',14,'yes','yes','no','no','no',NULL,18),(196,'check_interval','check interval','number of [min.] between regularly scheduled checks','text',4,'','','no',15,'yes','yes','no','no','no',NULL,18),(197,'retry_interval','retry interval','number of [min.] to wait before scheduling a re-check','text',4,'','','no',16,'yes','yes','no','no','no',NULL,18),(198,'first_notification_delay','first notification delay','number of [min.] to wait before sending the first notification','text',4,'','','no',17,'yes','yes','no','no','no',NULL,18),(199,'notification_interval','notification interval','number of [min.] to wait before re-notifying a contact','text',4,'','','no',18,'yes','yes','no','no','no',NULL,18),(200,'notification_options','notification options','possible values: w,u,c,r,f,s,[n]','text',20,'','','no',19,'yes','yes','no','no','no',NULL,18),(201,'active_checks_enabled','active checking','do active checking of services','select',0,'0::1','','no',20,'yes','yes','no','no','no',NULL,18),(202,'passive_checks_enabled','passive checking','do passive checking of services','select',0,'0::1','','no',21,'yes','yes','no','no','no',NULL,18),(203,'notifications_enabled','notification enabled','send notifications for services','select',0,'0::1','','no',22,'yes','yes','no','no','no',NULL,18),(204,'check_freshness','check freshness','check age of last check results','select',0,'0::1','','no',23,'yes','yes','no','no','no',NULL,18),(205,'freshness_threshold','freshness threshold','age threshold in [sec.]','text',5,'','','no',24,'yes','yes','no','no','no',NULL,18),(206,'check_params','params for check command','','text',1024,'','!','no',25,'yes','no','no','no','no',NULL,18),(207,'max_check_attempts','max check attempts','number of times to retry checking','text',4,'','','no',18,'yes','yes','no','no','no',NULL,1),(208,'check_interval','check interval','number of [min.] between regularly scheduled checks','text',4,'','','no',19,'yes','yes','no','no','no',NULL,1),(209,'retry_interval','retry interval','number of [min.] to wait before scheduling a re-check','text',4,'','','no',20,'yes','yes','no','no','no',NULL,1),(210,'first_notification_delay','first notification delay','number of [min.] to wait before sending the first notification','text',4,'','','no',21,'yes','yes','no','no','no',NULL,1),(211,'notification_interval','notification interval','number of [min.] to wait before re-notifying a contact','text',4,'','','no',22,'yes','yes','no','no','no',NULL,1),(212,'notification_options','notification options','possible values: d,u,r,f,s,[n]','text',20,'','','no',23,'yes','yes','no','no','no',NULL,1),(213,'active_checks_enabled','active checking','do active checking of hosts','select',0,'0::1','','no',24,'yes','yes','no','no','no',NULL,1),(214,'passive_checks_enabled','passive checking','do passive checking of hosts','select',0,'0::1','','no',25,'yes','yes','no','no','no',NULL,1),(215,'notifications_enabled','notification enabled','send notifications for hosts','select',0,'0::1','','no',26,'yes','yes','no','no','no',NULL,1),(216,'check_freshness','check freshness','check age of last check results','select',0,'0::1','','no',27,'yes','yes','no','no','no',NULL,1),(217,'freshness_threshold','freshness threshold','age threshold in [sec.]','text',5,'','','no',28,'yes','yes','no','no','no',NULL,1),(218,'max_check_attempts','max check attempts','number of times to retry checking','text',4,'','','no',12,'yes','yes','no','no','no',NULL,3),(219,'check_interval','check interval','number of [min.] between regularly scheduled checks','text',4,'','','no',13,'yes','yes','no','no','no',NULL,3),(220,'retry_interval','retry interval','number of [min.] to wait before scheduling a re-check','text',4,'','','no',14,'yes','yes','no','no','no',NULL,3),(221,'first_notification_delay','first notification delay','number of [min.] to wait before sending the first notification','text',4,'','','no',15,'yes','yes','no','no','no',NULL,3),(222,'notification_interval','notification interval','number of [min.] to wait before re-notifying a contact','text',4,'','','no',16,'yes','yes','no','no','no',NULL,3),(223,'notification_options','notification options','possible values: w,u,c,r,f,s,[n]','text',20,'','','no',17,'yes','yes','no','no','no',NULL,3),(224,'active_checks_enabled','active checking','do active checking of services','select',0,'0::1','','no',18,'yes','yes','no','no','no',NULL,3),(225,'passive_checks_enabled','passive checking','do passive checking of services','select',0,'0::1','','no',19,'yes','yes','no','no','no',NULL,3),(226,'notifications_enabled','notification enabled','send notifications for services','select',0,'0::1','','no',20,'yes','yes','no','no','no',NULL,3),(227,'check_freshness','check freshness','check age of last check results','select',0,'0::1','','no',21,'yes','yes','no','no','no',NULL,3),(228,'freshness_threshold','freshness threshold','age threshold in [sec.]','text',5,'','','no',22,'yes','yes','no','no','no',NULL,3),(229,'first_notification_delay','first notification delay','number of [min.] to wait before sending the first notification','text',4,'','','no',15,'yes','yes','no','no','no',NULL,14),(230,'first_notification_delay','first notification delay','number of [min.] to wait before sending the first notification','text',4,'','','no',14,'yes','yes','no','no','no',NULL,15);
UNLOCK TABLES;
/*!40000 ALTER TABLE `ConfigAttrs` ENABLE KEYS */;

--
-- Table structure for table `ConfigClasses`
--

DROP TABLE IF EXISTS `ConfigClasses`;
CREATE TABLE `ConfigClasses` (
  `id_class` int(10) unsigned NOT NULL auto_increment,
  `config_class` varchar(50) NOT NULL default '',
  `friendly_name` varchar(80) NOT NULL,
  `nav_visible` enum('yes','no') NOT NULL default 'yes',
  `ordering` int(11) NOT NULL default '0',
  `grouping` varchar(30) NOT NULL,
  `nav_links` varchar(512) NOT NULL,
  `nav_privs` enum('user','admin') NOT NULL default 'admin',
  `class_type` enum('global','monitor','collector') NOT NULL default 'global',
  `out_file` varchar(50) default NULL,
  `nagios_object` varchar(50) default NULL,
  PRIMARY KEY  (`id_class`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

--
-- Dumping data for table `ConfigClasses`
--


/*!40000 ALTER TABLE `ConfigClasses` DISABLE KEYS */;
LOCK TABLES `ConfigClasses` WRITE;
INSERT INTO `ConfigClasses` VALUES (1,'host','Hosts','yes',1,'','Show::overview.php?class=host;;Add::handle_item.php?item=host','user','collector','hosts.cfg','host'),(2,'hostgroup','Hostgroups','yes',2,'','Show::overview.php?class=hostgroup;;Add::handle_item.php?item=hostgroup','user','collector','hostgroups.cfg','hostgroup'),(3,'service','Services','yes',3,'','Show::overview.php?class=service;;Add::handle_item.php?item=service','user','collector','services.cfg','service'),(4,'servicegroup','Servicegroups','yes',5,'','Show::overview.php?class=servicegroup;;Add::handle_item.php?item=servicegroup','user','collector','servicegroups.cfg','servicegroup'),(5,'contact','Contacts','yes',2,'','Show::overview.php?class=contact;;Add::handle_item.php?item=contact','admin','global','contacts.cfg','contact'),(6,'contactgroup','Contactgroups','yes',3,'','Show::overview.php?class=contactgroup;;Add::handle_item.php?item=contactgroup','admin','global','contactgroups.cfg','contactgroup'),(7,'timeperiod','Timeperiods','yes',6,'','Show::overview.php?class=timeperiod;;Add::handle_item.php?item=timeperiod','admin','global','timeperiods.cfg','timeperiod'),(8,'checkcommand','Checkcommands','yes',4,'','Show::overview.php?class=checkcommand;;Add::handle_item.php?item=checkcommand','admin','global','checkcommands.cfg','command'),(9,'os','OS','yes',1,'','Show::overview.php?class=os;;Add::handle_item.php?item=os','admin','global',NULL,NULL),(10,'nagios-collector','Distrib. collectors','yes',2,'Nagios servers','Show::overview.php?class=nagios-collector;;Add::handle_item.php?item=nagios-collector','admin','global',NULL,NULL),(11,'nagios-monitor','Central monitors','yes',1,'Nagios servers','Show::overview.php?class=nagios-monitor;;Add::handle_item.php?item=nagios-monitor','admin','global',NULL,NULL),(12,'host-preset','Host presets','yes',1,'Advanced Items','Show::overview.php?class=host-preset;;Add::handle_item.php?item=host-preset','admin','global',NULL,NULL),(13,'misccommand','Misccommands','yes',5,'','Show::overview.php?class=misccommand;;Add::handle_item.php?item=misccommand','admin','global','misccommands.cfg','command'),(14,'host-template','Host templates','yes',2,'Advanced Items','Show::overview.php?class=host-template;;Add::handle_item.php?item=host-template','admin','global','host_templates.cfg','host'),(15,'service-template','Service templates','yes',3,'Advanced Items','Show::overview.php?class=service-template;;Add::handle_item.php?item=service-template','admin','global','service_templates.cfg','service'),(16,'host-dependency','Host deps.','yes',4,'Advanced Items','Show::overview.php?class=host-dependency;;Add::handle_item.php?item=host-dependency','admin','collector','host_dependencies.cfg','hostdependency'),(17,'service-dependency','Service deps.','yes',5,'Advanced Items','Show::overview.php?class=service-dependency;;Add::handle_item.php?item=service-dependency','admin','collector','service_dependencies.cfg','servicedependency'),(18,'advanced-service','Advanced Services','yes',4,'','Show::overview.php?class=advanced-service;;Add::handle_item.php?item=advanced-service','user','collector','advanced_services.cfg','service');
UNLOCK TABLES;
/*!40000 ALTER TABLE `ConfigClasses` ENABLE KEYS */;

--
-- Table structure for table `ConfigItems`
--

DROP TABLE IF EXISTS `ConfigItems`;
CREATE TABLE `ConfigItems` (
  `id_item` int(10) unsigned NOT NULL auto_increment,
  `fk_id_class` int(10) unsigned NOT NULL default '0',
  PRIMARY KEY  (`id_item`),
  KEY `fk_id_class` (`fk_id_class`),
  CONSTRAINT `ConfigItems_ibfk_1` FOREIGN KEY (`fk_id_class`) REFERENCES `ConfigClasses` (`id_class`) ON DELETE CASCADE ON UPDATE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

--
-- Dumping data for table `ConfigItems`
--


/*!40000 ALTER TABLE `ConfigItems` DISABLE KEYS */;
LOCK TABLES `ConfigItems` WRITE;
INSERT INTO `ConfigItems` VALUES (5340,1),(5341,1),(5342,1),(5343,1),(5344,2),(5345,2),(5346,2),(5347,2),(5350,3),(5351,3),(5352,3),(5353,3),(5354,3),(5275,4),(5333,5),(5334,6),(5305,7),(5306,7),(5307,7),(5308,8),(5309,8),(5310,8),(5311,8),(5312,8),(5313,8),(5314,8),(5315,8),(5316,8),(5317,8),(5318,8),(5319,8),(5320,8),(5321,8),(5322,8),(5323,8),(5324,8),(5325,8),(5326,8),(5,9),(7,9),(2528,9),(5254,9),(5255,9),(5256,9),(5257,9),(5277,9),(1,10),(5231,12),(5258,12),(5259,12),(5276,12),(5296,13),(5327,13),(5328,13),(5329,13),(5330,13),(5331,13),(5297,14),(5298,14),(5335,14),(5336,14),(5337,14),(5338,14),(5339,14),(5301,15),(5302,15),(5348,15),(5349,15),(5355,18),(5356,18),(5357,18),(5358,18),(5359,18),(5360,18),(5361,18),(5362,18),(5363,18),(5364,18),(5365,18),(5366,18),(5367,18),(5368,18),(5369,18),(5370,18);
UNLOCK TABLES;
/*!40000 ALTER TABLE `ConfigItems` ENABLE KEYS */;

--
-- Table structure for table `ConfigValues`
--

DROP TABLE IF EXISTS `ConfigValues`;
CREATE TABLE `ConfigValues` (
  `attr_value` varchar(1024) default NULL,
  `fk_id_attr` int(10) unsigned NOT NULL default '0',
  `fk_id_item` int(10) unsigned NOT NULL default '0',
  PRIMARY KEY  (`fk_id_attr`,`fk_id_item`),
  KEY `fk_id_item` (`fk_id_item`),
  CONSTRAINT `ConfigValues_ibfk_1` FOREIGN KEY (`fk_id_attr`) REFERENCES `ConfigAttrs` (`id_attr`) ON DELETE CASCADE ON UPDATE CASCADE,
  CONSTRAINT `ConfigValues_ibfk_2` FOREIGN KEY (`fk_id_item`) REFERENCES `ConfigItems` (`id_item`) ON DELETE CASCADE ON UPDATE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

--
-- Dumping data for table `ConfigValues`
--


/*!40000 ALTER TABLE `ConfigValues` DISABLE KEYS */;
LOCK TABLES `ConfigValues` WRITE;
INSERT INTO `ConfigValues` VALUES ('Default Nagios',1,1),('Linux',12,5),('Windows Server',12,7),('Sun Solaris',12,2528),('HP Unix',12,5254),('Free BSD',12,5255),('Router',12,5256),('Switch',12,5257),('HP Printer',12,5277),('base/linux40.gif',13,5),('base/win40.gif',13,7),('base/sunlogo.gif',13,2528),('base/hpux.gif',13,5254),('base/freebsd40.gif',13,5255),('base/router40.gif',13,5256),('base/switch40.gif',13,5257),('base/hp-printer40.gif',13,5277),('base/linux40.gd2',14,5),('base/win40.gd2',14,7),('base/sunlogo.gd2',14,2528),('base/hpux.gd2',14,5254),('base/freebsd40.gd2',14,5255),('base/router40.gd2',14,5256),('base/switch40.gd2',14,5257),('base/hp-printer40.gd2',14,5277),('localhost',15,5340),('hplj2605dn',15,5341),('linksys-srw224p',15,5342),('winserver',15,5343),('localhost',16,5340),('HP LaserJet 2605dn',16,5341),('Linksys SRW224P Switch',16,5342),('My Windows Server',16,5343),('127.0.0.1',17,5340),('192.168.1.30',17,5341),('192.168.1.253',17,5342),('192.168.1.2',17,5343),('',24,5340),('',24,5341),('',24,5342),('',24,5343),('',25,5340),('',25,5341),('',25,5342),('',25,5343),('windows-servers',27,5344),('switches',27,5345),('network-printers',27,5346),('linux-servers',27,5347),('Windows Servers',28,5344),('Network Switches',28,5345),('Network Printers',28,5346),('Linux Servers',28,5347),('check_local_disk',30,5308),('check_local_load',30,5309),('check_local_procs',30,5310),('check_local_users',30,5311),('check_local_swap',30,5312),('check_local_mrtgtraf',30,5313),('check_ftp',30,5314),('check_hpjd',30,5315),('check_snmp',30,5316),('check_http',30,5317),('check_ssh',30,5318),('check_dhcp',30,5319),('check_ping',30,5320),('check_pop',30,5321),('check_imap',30,5322),('check_smtp',30,5323),('check_tcp',30,5324),('check_udp',30,5325),('check_nt',30,5326),('$USER1$/check_disk -w $ARG1$ -c $ARG2$ -p $ARG3$',31,5308),('$USER1$/check_load -w $ARG1$ -c $ARG2$',31,5309),('$USER1$/check_procs -w $ARG1$ -c $ARG2$ -s $ARG3$',31,5310),('$USER1$/check_users -w $ARG1$ -c $ARG2$',31,5311),('$USER1$/check_swap -w $ARG1$ -c $ARG2$',31,5312),('$USER1$/check_mrtgtraf -F $ARG1$ -a $ARG2$ -w $ARG3$ -c $ARG4$ -e $ARG5$',31,5313),('$USER1$/check_ftp -H $HOSTADDRESS$ $ARG1$',31,5314),('$USER1$/check_hpjd -H $HOSTADDRESS$ $ARG1$',31,5315),('$USER1$/check_snmp -H $HOSTADDRESS$ $ARG1$',31,5316),('$USER1$/check_http -I $HOSTADDRESS$ $ARG1$',31,5317),('$USER1$/check_ssh $ARG1$ $HOSTADDRESS$',31,5318),('$USER1$/check_dhcp $ARG1$',31,5319),('$USER1$/check_ping -H $HOSTADDRESS$ -w $ARG1$ -c $ARG2$ -p 5',31,5320),('$USER1$/check_pop -H $HOSTADDRESS$ $ARG1$',31,5321),('$USER1$/check_imap -H $HOSTADDRESS$ $ARG1$',31,5322),('$USER1$/check_smtp -H $HOSTADDRESS$ $ARG1$',31,5323),('$USER1$/check_tcp -H $HOSTADDRESS$ -p $ARG1$ $ARG2$',31,5324),('$USER1$/check_udp -H $HOSTADDRESS$ -p $ARG1$ $ARG2$',31,5325),('$USER1$/check_nt -H $HOSTADDRESS$ -p 12489 -v $ARG1$ $ARG2$',31,5326),('24x7',32,5305),('workhours',32,5306),('none',32,5307),('24 Hours A Day, 7 Days A Week',33,5305),('Normal Work Hours',33,5306),('No Time Is A Good Time',33,5307),('00:00-24:00',34,5305),('00:00-24:00',35,5305),('09:00-17:00',35,5306),('00:00-24:00',36,5305),('09:00-17:00',36,5306),('00:00-24:00',37,5305),('09:00-17:00',37,5306),('00:00-24:00',38,5305),('09:00-17:00',38,5306),('00:00-24:00',39,5305),('09:00-17:00',39,5306),('00:00-24:00',40,5305),('nagiosadmin',47,5333),('Nagios Admin',48,5333),('d,u,r,f,s',51,5333),('w,u,c,r,f,s',52,5333),('nagios@localhost',55,5333),('admins',57,5334),('Nagios Administrators',58,5334),('Root Partition',60,5350),('Printer Status',60,5351),('Port 1 Link Status',60,5352),('Port 1 Bandwidth Usage',60,5353),('W3SVC',60,5354),('0',69,5350),('0',69,5351),('0',69,5352),('0',69,5353),('0',69,5354),('web-services',70,5275),('Web Services',71,5275),('linux-server',73,5231),('windows-server',73,5258),('generic-switch',73,5259),('generic-printer',73,5276),('!20%!10%!/',79,5350),('!-C public',79,5351),('!-C public -o ifOperStatus.1 -r 1 -m RFC1213-MIB',79,5352),('!/var/lib/mrtg/192.168.1.253_1.log!AVG!1000000,1000000!5000000,5000000!10',79,5353),('!SERVICESTATE!-d SHOWALL -l W3SVC',79,5354),('ARG1=% warning threshold, ARG2=% critical threshold, ARG3=path',86,5308),('ARG1=warning LOAD1&#44LOAD5&#44LOAD15, ARG2=critical LOAD1&#44LOAD5&#44LOAD15',86,5309),('ARG1=warning range,ARG2=critical range,ARG3=state',86,5310),('ARG1=warning users,ARG2=critical users',86,5311),('ARG1=warning free [% | bytes],ARG2=critical free [% | bytes]',86,5312),('ARG1=log_file,ARG2=[AVG | MAX],ARG3=warning_pair,ARG4=critical_pair,ARG5=expire minutes',86,5313),('ARG1=Multiple options - see command syntax',86,5314),('ARG1=Multiple options - see command syntax',86,5315),('ARG1=Multiple options - see command syntax',86,5316),('ARG1=Multiple options - see command syntax',86,5317),('ARG1=Multiple options - see command syntax',86,5318),('ARG1=Multiple options - see command syntax',86,5319),('ARG1=warning rta [ms]&#44wpl [%],ARG2=critical rta [ms]&#44wpl [%]',86,5320),('ARG1=Multiple options - see command syntax',86,5321),('ARG1=Multiple options - see command syntax',86,5322),('ARG1=Multiple options - see command syntax',86,5323),('ARG1=TCP port,ARG2=Multiple options - see command syntax',86,5324),('ARG1=UDP port,ARG2=Multiple options - see command syntax',86,5325),('ARG1=Variable,ARG2=Multiple options - see command syntax',86,5326),('!10%!5%!/',87,5308),('!5.0,4.0,3.0!10.0,6.0,4.0',87,5309),('!',87,5310),('!',87,5311),('!',87,5312),('!',87,5313),('!',87,5314),('!',87,5315),('!',87,5316),('!',87,5317),('!',87,5318),('!',87,5319),('!3000.0,80%!5000.0,100%',87,5320),('!',87,5321),('!',87,5322),('!',87,5323),('!',87,5324),('!',87,5325),('!',87,5326),('no',93,5340),('no',93,5341),('no',93,5342),('no',93,5343),('3',94,5308),('2',94,5309),('3',94,5310),('2',94,5311),('2',94,5312),('5',94,5313),('1',94,5314),('1',94,5315),('1',94,5316),('1',94,5317),('1',94,5318),('1',94,5319),('2',94,5320),('1',94,5321),('1',94,5322),('1',94,5323),('2',94,5324),('2',94,5325),('2',94,5326),('user',96,5333),('enabled',97,5333),('service_is_stale',98,5296),('notify-host-by-email',98,5327),('notify-service-by-email',98,5328),('process-host-perfdata',98,5329),('process-service-perfdata',98,5330),('check-host-alive',98,5331),('/usr/lib/nagios/plugins/eventhandlers/stale_service.sh',99,5296),('/usr/bin/printf \"%b\" \"***** Nagios *****\\n\\nNotification Type: $NOTIFICATIONTYPE$\\nHost: $HOSTNAME$\\nState: $HOSTSTATE$\\nAddress: $HOSTADDRESS$\\nInfo: $HOSTOUTPUT$\\n\\nDate/Time: $LONGDATETIME$\\n\" | /bin/mail -s \"** $NOTIFICATIONTYPE$ Host Alert: $HOSTNAME$ is $HOSTSTATE$ **\" $CONTACTEMAIL$',99,5327),('/usr/bin/printf \"%b\" \"***** Nagios *****\\n\\nNotification Type: $NOTIFICATIONTYPE$\\n\\nService: $SERVICEDESC$\\nHost: $HOSTALIAS$\\nAddress: $HOSTADDRESS$\\nState: $SERVICESTATE$\\n\\nDate/Time: $LONGDATETIME$\\n\\nAdditional Info:\\n\\n$SERVICEOUTPUT$\\n\" | /bin/mail -s \"** $NOTIFICATIONTYPE$ Service Alert: $HOSTALIAS$/$SERVICEDESC$ is $SERVICESTATE$ **\" $CONTACTEMAIL$',99,5328),('/usr/bin/printf \"%b\" \"$LASTHOSTCHECK$\\t$HOSTNAME$\\t$HOSTSTATE$\\t$HOSTATTEMPT$\\t$HOSTSTATETYPE$\\t$HOSTEXECUTIONTIME$\\t$HOSTOUTPUT$\\t$HOSTPERFDATA$\\n\" >> /usr/local/nagios/var/host-perfdata.out',99,5329),('/usr/bin/printf \"%b\" \"$LASTSERVICECHECK$\\t$HOSTNAME$\\t$SERVICEDESC$\\t$SERVICESTATE$\\t$SERVICEATTEMPT$\\t$SERVICESTATETYPE$\\t$SERVICEEXECUTIONTIME$\\t$SERVICELATENCY$\\t$SERVICEOUTPUT$\\t$SERVICEPERFDATA$\\n\" >> /usr/local/nagios/var/service-perfdata.out',99,5330),('$USER1$/check_ping -H $HOSTADDRESS$ -w 3000.0,80% -c 5000.0,100% -p 5',99,5331),('',101,5340),('',101,5341),('',101,5342),('',101,5343),('',103,5308),('',103,5309),('',103,5310),('',103,5311),('',103,5312),('',103,5313),('',103,5314),('',103,5315),('',103,5316),('',103,5317),('',103,5318),('',103,5319),('',103,5320),('',103,5321),('',103,5322),('',103,5323),('',103,5324),('',103,5325),('',103,5326),('',106,5275),('',107,5275),('Default_collector_server',108,5297),('Default_monitor_server',108,5298),('generic-host',108,5335),('linux-server',108,5336),('windows-server',108,5337),('generic-printer',108,5338),('generic-switch',108,5339),('0',110,5297),('0',110,5298),('0',110,5335),('0',110,5336),('0',110,5337),('0',110,5338),('0',110,5339),('10',119,5336),('10',119,5337),('10',119,5338),('10',119,5339),('5',120,5336),('5',120,5337),('5',120,5338),('5',120,5339),('1',121,5336),('1',121,5337),('1',121,5338),('1',121,5339),('120',122,5336),('30',122,5337),('30',122,5338),('30',122,5339),('d,u,r',123,5336),('d,r',123,5337),('d,r',123,5338),('d,r',123,5339),('1',124,5297),('0',124,5298),('0',125,5297),('1',125,5298),('1',126,5297),('1',126,5298),('1',126,5335),('0',127,5297),('0',127,5298),('86400',128,5297),('86400',128,5298),('Default_collector_server',129,5301),('Default_monitor_server',129,5302),('generic-service',129,5348),('local-service',129,5349),('0',131,5301),('0',131,5302),('0',131,5348),('0',131,5349),('3',139,5348),('4',139,5349),('10',140,5348),('5',140,5349),('2',141,5348),('1',141,5349),('60',142,5348),('w,u,c,r',143,5348),('1',144,5301),('0',144,5302),('1',144,5348),('0',145,5301),('1',145,5302),('1',145,5348),('1',146,5301),('1',146,5302),('1',146,5348),('0',147,5301),('0',147,5302),('0',147,5348),('86400',148,5301),('86400',148,5302),('yes',174,5350),('yes',174,5351),('yes',174,5352),('yes',174,5353),('yes',174,5354),('',180,5308),('',180,5309),('',180,5310),('',180,5311),('',180,5312),('',180,5313),('',180,5314),('',180,5315),('',180,5316),('',180,5317),('',180,5318),('',180,5319),('',180,5320),('',180,5321),('',180,5322),('',180,5323),('',180,5324),('',180,5325),('',180,5326),('',181,5308),('',181,5309),('',181,5310),('',181,5311),('',181,5312),('',181,5313),('',181,5314),('',181,5315),('',181,5316),('',181,5317),('',181,5318),('',181,5319),('',181,5320),('',181,5321),('',181,5322),('',181,5323),('',181,5324),('',181,5325),('',181,5326),('PING',182,5355),('Current Users',182,5356),('Total Processes',182,5357),('Current Load',182,5358),('Swap Usage',182,5359),('SSH',182,5360),('HTTP',182,5361),('PING interval 10',182,5362),('PING interval 5',182,5363),('Uptime SNMP',182,5364),('NSClient++ Version',182,5365),('Uptime Windows',182,5366),('CPU Load',182,5367),('Memory Usage',182,5368),('C:\\ Drive Space',182,5369),('Explorer',182,5370),('PING',183,5355),('Current Users',183,5356),('Total Processes',183,5357),('Current Load',183,5358),('Swap Usage',183,5359),('SSH',183,5360),('HTTP',183,5361),('PING',183,5362),('PING',183,5363),('Uptime',183,5364),('NSClient++ Version',183,5365),('Uptime',183,5366),('CPU Load',183,5367),('Memory Usage',183,5368),('C:\\ Drive Space',183,5369),('Explorer',183,5370),('',192,5362),('',192,5363),('',192,5364),('',192,5366),('',193,5362),('',193,5363),('',193,5364),('',193,5366),('',194,5362),('',194,5363),('',194,5364),('',194,5366),('',195,5362),('',195,5363),('',195,5364),('',195,5366),('10',196,5362),('5',196,5363),('',196,5364),('',196,5366),('1',197,5362),('1',197,5363),('',197,5364),('',197,5366),('',198,5362),('',198,5363),('',198,5364),('',198,5366),('',199,5362),('',199,5363),('',199,5364),('',199,5366),('',200,5362),('',200,5363),('',200,5364),('',200,5366),('',201,5362),('',201,5363),('',201,5364),('',201,5366),('',202,5362),('',202,5363),('',202,5364),('',202,5366),('0',203,5360),('0',203,5361),('',203,5362),('',203,5363),('',203,5364),('',203,5366),('',204,5362),('',204,5363),('',204,5364),('',204,5366),('',205,5362),('',205,5363),('',205,5364),('',205,5366),('!100.0,20%!500.0,60%',206,5355),('!20!50',206,5356),('!250!400!RSZDT',206,5357),('!5.0,4.0,3.0!10.0,6.0,4.0',206,5358),('!20!10',206,5359),('!',206,5360),('!',206,5361),('!3000.0,80%!5000.0,100%',206,5362),('!200.0,20%!600.0,60%',206,5363),('!-C public -o sysUpTime.0',206,5364),('!CLIENTVERSION',206,5365),('!UPTIME',206,5366),('!CPULOAD!-l 5,80,90',206,5367),('!MEMUSE!-w 80 -c 90',206,5368),('!USEDDISKSPACE!-l c -w 80 -c 90',206,5369),('!PROCSTATE!-d SHOWALL -l Explorer.exe',206,5370),('',207,5340),('',207,5341),('',207,5342),('',207,5343),('',208,5340),('',208,5341),('',208,5342),('',208,5343),('',209,5340),('',209,5341),('',209,5342),('',209,5343),('',210,5340),('',210,5341),('',210,5342),('',210,5343),('',211,5340),('',211,5341),('',211,5342),('',211,5343),('',212,5340),('',212,5341),('',212,5342),('',212,5343),('',213,5340),('',213,5341),('',213,5342),('',213,5343),('',214,5340),('',214,5341),('',214,5342),('',214,5343),('',215,5340),('',215,5341),('',215,5342),('',215,5343),('',216,5340),('',216,5341),('',216,5342),('',216,5343),('',217,5340),('',217,5341),('',217,5342),('',217,5343),('10',219,5351),('1',220,5351);
UNLOCK TABLES;
/*!40000 ALTER TABLE `ConfigValues` ENABLE KEYS */;

--
-- Table structure for table `History`
--

DROP TABLE IF EXISTS `History`;
CREATE TABLE `History` (
  `id_hist` int(10) unsigned NOT NULL auto_increment,
  `timestamp` timestamp NOT NULL default CURRENT_TIMESTAMP on update CURRENT_TIMESTAMP,
  `user_str` varchar(250) NOT NULL,
  `action` enum('created','added','assigned','unassigned','modified','edited','removed','general','module') NOT NULL,
  `attr_name` varchar(80) NOT NULL,
  `attr_value` varchar(1024) default NULL,
  `fk_id_item` int(10) unsigned default NULL,
  PRIMARY KEY  (`id_hist`),
  KEY `fk_id_item` (`fk_id_item`),
  CONSTRAINT `History_ibfk_1` FOREIGN KEY (`fk_id_item`) REFERENCES `ConfigItems` (`id_item`) ON DELETE SET NULL ON UPDATE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

--
-- Dumping data for table `History`
--


/*!40000 ALTER TABLE `History` DISABLE KEYS */;
LOCK TABLES `History` WRITE;
UNLOCK TABLES;
/*!40000 ALTER TABLE `History` ENABLE KEYS */;

--
-- Table structure for table `ItemLinks`
--

DROP TABLE IF EXISTS `ItemLinks`;
CREATE TABLE `ItemLinks` (
  `fk_id_item` int(10) unsigned NOT NULL default '0',
  `fk_item_linked2` int(10) unsigned NOT NULL default '0',
  `fk_id_attr` int(10) unsigned NOT NULL default '0',
  `cust_order` int(11) NOT NULL default '0',
  PRIMARY KEY  (`fk_id_item`,`fk_item_linked2`,`fk_id_attr`),
  KEY `fk_item_linked2` (`fk_item_linked2`),
  KEY `fk_id_attr` (`fk_id_attr`),
  CONSTRAINT `ItemLinks_ibfk_1` FOREIGN KEY (`fk_id_item`) REFERENCES `ConfigItems` (`id_item`) ON DELETE CASCADE ON UPDATE CASCADE,
  CONSTRAINT `ItemLinks_ibfk_2` FOREIGN KEY (`fk_item_linked2`) REFERENCES `ConfigItems` (`id_item`) ON DELETE CASCADE ON UPDATE CASCADE,
  CONSTRAINT `ItemLinks_ibfk_3` FOREIGN KEY (`fk_id_attr`) REFERENCES `ConfigAttrs` (`id_attr`) ON DELETE CASCADE ON UPDATE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

--
-- Dumping data for table `ItemLinks`
--


/*!40000 ALTER TABLE `ItemLinks` DISABLE KEYS */;
LOCK TABLES `ItemLinks` WRITE;
INSERT INTO `ItemLinks` VALUES (5231,5331,81,0),(5258,5331,81,0),(5259,5331,81,0),(5276,5331,81,0),(5333,5305,49,0),(5333,5305,50,0),(5333,5327,53,0),(5333,5328,54,0),(5333,5334,59,0),(5335,5305,112,0),(5336,5305,111,0),(5336,5306,112,0),(5336,5331,113,0),(5336,5334,115,0),(5336,5335,114,1),(5337,5305,111,0),(5337,5305,112,0),(5337,5331,113,0),(5337,5334,115,0),(5337,5335,114,1),(5338,5305,111,0),(5338,5306,112,0),(5338,5331,113,0),(5338,5334,115,0),(5338,5335,114,1),(5339,5305,111,0),(5339,5305,112,0),(5339,5331,113,0),(5339,5334,115,0),(5339,5335,114,1),(5340,1,26,0),(5340,5,18,0),(5340,5231,75,0),(5340,5336,149,1),(5340,5342,23,0),(5340,5347,29,0),(5341,1,26,0),(5341,5276,75,0),(5341,5277,18,0),(5341,5338,149,1),(5341,5342,23,0),(5341,5346,29,0),(5342,1,26,0),(5342,5257,18,0),(5342,5259,75,0),(5342,5339,149,1),(5342,5345,29,0),(5343,1,26,0),(5343,7,18,0),(5343,5258,75,0),(5343,5337,149,1),(5343,5342,23,0),(5343,5344,29,0),(5348,5305,132,0),(5348,5305,133,0),(5348,5334,135,0),(5349,5348,134,1),(5350,5308,61,0),(5350,5340,62,0),(5350,5349,150,1),(5351,5315,61,0),(5351,5341,62,0),(5351,5348,150,1),(5352,5316,61,0),(5352,5342,62,0),(5352,5348,150,1),(5353,5313,61,0),(5353,5342,62,0),(5353,5348,150,1),(5354,5326,61,0),(5354,5343,62,0),(5354,5348,150,1),(5355,5320,184,0),(5355,5347,188,0),(5355,5349,190,1),(5356,5311,184,0),(5356,5347,188,0),(5356,5349,190,1),(5357,5310,184,0),(5357,5347,188,0),(5357,5349,190,1),(5358,5309,184,0),(5358,5347,188,0),(5358,5349,190,1),(5359,5312,184,0),(5359,5347,188,0),(5359,5349,190,1),(5360,5318,184,0),(5360,5347,188,0),(5360,5349,190,1),(5361,5275,189,0),(5361,5317,184,0),(5361,5347,188,0),(5361,5349,190,1),(5362,5320,184,0),(5362,5346,188,0),(5362,5348,190,1),(5363,5320,184,0),(5363,5345,188,0),(5363,5348,190,1),(5364,5316,184,0),(5364,5345,188,0),(5364,5348,190,1),(5365,5326,184,0),(5365,5344,188,0),(5365,5348,190,1),(5366,5326,184,0),(5366,5344,188,0),(5366,5348,190,1),(5367,5326,184,0),(5367,5344,188,0),(5367,5348,190,1),(5368,5326,184,0),(5368,5344,188,0),(5368,5348,190,1),(5369,5326,184,0),(5369,5344,188,0),(5369,5348,190,1),(5370,5326,184,0),(5370,5344,188,0),(5370,5348,190,1);
UNLOCK TABLES;
/*!40000 ALTER TABLE `ItemLinks` ENABLE KEYS */;
/*!40103 SET TIME_ZONE=@OLD_TIME_ZONE */;

/*!40101 SET SQL_MODE=@OLD_SQL_MODE */;
/*!40014 SET FOREIGN_KEY_CHECKS=@OLD_FOREIGN_KEY_CHECKS */;
/*!40014 SET UNIQUE_CHECKS=@OLD_UNIQUE_CHECKS */;
/*!40101 SET CHARACTER_SET_CLIENT=@OLD_CHARACTER_SET_CLIENT */;
/*!40101 SET CHARACTER_SET_RESULTS=@OLD_CHARACTER_SET_RESULTS */;
/*!40101 SET COLLATION_CONNECTION=@OLD_COLLATION_CONNECTION */;
/*!40111 SET SQL_NOTES=@OLD_SQL_NOTES */;

# -- add history entry for installation --
INSERT INTO History (user_str, action, attr_name, attr_value) VALUES ('NConf Setup','general','installed','NConf 1.3.0');
